(function($) {

	$(document).ready(function() {

		var nameArray = [];
		
		//call this function when user clicks add
		$.fn.add = function(){
			$('.error').remove();
			var input = $(this).val();
			var error = '';
			if(input.indexOf('=')>-1)
			{
				input = input.split('=');
				var name = input[0].trim();
				var value = input[1].trim();
				var letters = /^[a-zA-Z0-9]+$/;
				
				// validate name and value
				if(!letters.test(name))
				{
					error = 'Name Should be alpha-numeric. ';
				}
				if(!letters.test(value))
				{
					error += 'Value Should be alpha-numeric. ';
				}
				
				if(error!='')
				{
					//display error
					$(this).after('<div class="error">' + error + '</div>');
				}
				else
				{
					nameArray.push({n:name,v:value});
					var id = nameArray.length - 1;
					$('.store').prepend('<div id="pos-' + id + '" style="position:absolute;margin-top:-53px;">' + name + '=' + value + '</div>');					
					$('#pos-' + id).click(function(){		
						$(this).toggleClass('selected');		
					});
					$(this).val('');
					
					// animation part
					$('#pos-' + id).animate({'margin-top':'-15px'},200,function(){			
					$(this).css({'position':'',"margin-top":""});					
					});					
					$('.store div:nth-child(2)').animate({'margin-top':'20px'},200,function(){					
					$(this).css({'position':'',"margin-top":""});					
					});
					
					
				}
				
			}
			else
			{		
				if(input.trim()=='')
				{
					error = 'Please Enter Name=Value';
				}
				else
				{
					error = 'Invalid Pattern. Pattern should be Name=Value';
				}
				//display error
				$(this).after('<div class="error">' + error + '</div>');
			}
			
		};
		
		//call this function when user clicks delete button
		$.fn.deletee = function(){
			var deletIds = [];
			$(this).each(function(){
					var id = $(this).attr('id').replace('pos-','');
					deletIds.push(parseInt(id));					
				});
			
			//remove from array
			var alen = nameArray.length;
			var finalArr = [];
			for(j=0;j<alen;j++)
			{
				if($.inArray(j,deletIds)==-1)
				{
					finalArr.push(nameArray[j]);
				}
			}
			
			nameArray = finalArr;
			$('.store').populate();
		};
		
		//call this function when user clicks sort by name button
		$.fn.sname = function(){
			//sort by name
			nameArray.sort(function(a,b){			
			if(a.n > b.n){ return 1}
			if(a.n < b.n){ return -1}
			  return 0;			
			});
			
			$(this).populate();
		};
		
		//call this function when user clicks sort by value button
		$.fn.svalue = function(){
			//sort by value
			nameArray.sort(function(a,b){			
			if(a.v > b.v){ return 1}
			if(a.v < b.v){ return -1}
			  return 0;			
			});
			
			$(this).populate();
		};
		
		//call this function when user clicks show xml button
		$.fn.showxml = function(){
			$('.xml-bg').fadeIn();
			$(this).fadeIn();
			var outPut = '<div class="xml-close">Close</div><div class="tag-0">&lt;?xml version="1.0" encoding="UTF-8"?&gt;</div><div class="tag-0">&lt;list&gt;</div>';
			
			for(k in nameArray)
			{
				outPut += '<div class="tag-1">&lt;pair&gt;</div><div class="tag-2">&lt;name&gt;</div><span>' + nameArray[k].n + '</span><div class="tag-3">&lt;/name&gt;</div><br><div class="tag-2">&lt;value&gt;</div><span>' + nameArray[k].v + '</span><div class="tag-3">&lt;/value&gt;</div><div class="tag-1">&lt;/pair&gt;</div>';
			}
			outPut += '<div class="tag-0">&lt;/list&gt;</div>';
			$(this).html(outPut);
				
			$('.xml-close').click(function(){		
				$('.xml-container').fadeOut();
				$('.xml-bg').fadeOut();
			});
			
		};
		
		//populate when user click sort		
		$.fn.populate = function(){
			var outPut = '';
			for(k in nameArray)
			{
				outPut += '<div id="pos-' + k + '" >' + nameArray[k].n + '=' + nameArray[k].v + '</div>';
			}
			$(this).html(outPut);
			$(this).find('div').click(function(){	
					$(this).toggleClass('selected');		
			});
		};
		
		
		//add name/value pair
		$('#add').click(function(){		
			$('#pair-input').add();		
		});
		
		//delete selected
		$('#delete').click(function(){		
			$('.store .selected').deletee();
		});
		
		//sort by name
		$('#sort-name').click(function(){		
			$('.store').sname();
		});
		
		//sort by value
		$('#sort-value').click(function(){		
			$('.store').svalue();
		});
		
		//select all
		$('#select-all').click(function(){	
			if($('.store div').hasClass('selected'))
			$('.store div').removeClass('selected');
			else
			$('.store div').addClass('selected');
		});
			
		//show xml values
		$('#show-xml').click(function(){		
			$('.xml-container').showxml();
		});
		
		
	});
		
})(jQuery);

String.prototype.trim=function(){return this.replace(/^\s+|\s+$/g, '');}